aboutsummaryrefslogtreecommitdiffstats
path: root/test-tools
diff options
context:
space:
mode:
authordanielhanrahan <daniel.hanrahan@est.tech>2023-03-05 12:20:40 +0000
committersourabh_sourabh <sourabh.sourabh@est.tech>2023-03-20 15:55:40 +0000
commit9c8b57d4ff1c8a70c65d04694cb1c164c5e770ad (patch)
tree4dc1c0265fecf1ca88fea433cdf5f2243d375d01 /test-tools
parent0b00f81b98e5fa9632b1145e49f62d0b2712f4e4 (diff)
Script to diff metrics reports
- Added Python script to subtract metrics reports - Moved scripts to test-tools/ folder Issue-ID: CPS-1551 Signed-off-by: danielhanrahan <daniel.hanrahan@est.tech> Change-Id: I4547eb523135dfc0441b5d47ab7f81b184bf836a
Diffstat (limited to 'test-tools')
-rwxr-xr-xtest-tools/generate-metrics-report.sh109
-rwxr-xr-xtest-tools/subtract-metrics-reports.py80
2 files changed, 189 insertions, 0 deletions
diff --git a/test-tools/generate-metrics-report.sh b/test-tools/generate-metrics-report.sh
new file mode 100755
index 000000000..f1eac1471
--- /dev/null
+++ b/test-tools/generate-metrics-report.sh
@@ -0,0 +1,109 @@
+#!/bin/bash
+#
+# Copyright 2023 Nordix Foundation.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+set -o errexit # Exit on most errors
+set -o nounset # Disallow expansion of unset variables
+set -o pipefail # Use last non-zero exit code in a pipeline
+#set -o xtrace # Uncomment for debugging
+
+function script_usage() {
+ cat <<EOF
+Usage:
+ -h|--help Displays this help
+ -u|--metrics-url=URL URL to Prometheus metrics
+ Default: http://localhost:8887/manage/prometheus
+ -o|--output=FILE Path to output file
+ Default: metrics-reports/metrics-[timestamp].tsv
+EOF
+}
+
+function parse_params() {
+ # Set parameter defaults
+ METRICS_URL="http://localhost:8887/manage/prometheus"
+ OUTFILE="metrics-reports/metrics-$(date --iso-8601=seconds).tsv"
+ TEMP_DIR="/tmp/cps-metrics"
+
+ # Parse parameters
+ local param
+ while [[ $# -gt 0 ]]; do
+ param="$1"
+ shift
+ case $param in
+ -h | --help)
+ script_usage
+ exit 0
+ ;;
+ -u | --metrics-url)
+ METRICS_URL=$1
+ shift
+ ;;
+ -o | --output)
+ OUTFILE=$1
+ shift
+ ;;
+ *)
+ echo "Invalid parameter was provided: $param" >&2
+ script_usage
+ exit 1
+ ;;
+ esac
+ done
+}
+
+function generate_report() {
+ # Create needed directories.
+ mkdir -p $TEMP_DIR "$(dirname "$OUTFILE")"
+
+ # Scrape raw metrics (suppress progress meter).
+ curl --fail --silent --show-error --output $TEMP_DIR/metrics-raw.txt "$METRICS_URL"
+
+ # Remove comments, sort by name, and separate by tabs.
+ grep --invert-match "^#" $TEMP_DIR/metrics-raw.txt | sort | sed 's/,[}]/}\t/' >$TEMP_DIR/metrics-all.txt
+
+ # Extract useful metrics.
+ grep -E "^cps_|^spring_data_" $TEMP_DIR/metrics-all.txt >$TEMP_DIR/metrics-cps.txt
+
+ # Extract into columns.
+ grep "_count" $TEMP_DIR/metrics-cps.txt | sed 's/_count//' | cut -f 1 >$TEMP_DIR/column1.txt
+ grep "_count" $TEMP_DIR/metrics-cps.txt | cut -f 2 >$TEMP_DIR/column2.txt
+ grep "_sum" $TEMP_DIR/metrics-cps.txt | cut -f 2 >$TEMP_DIR/column3.txt
+ grep "_max" $TEMP_DIR/metrics-cps.txt | cut -f 2 >$TEMP_DIR/column4.txt
+
+ # Combine columns into report.
+ paste $TEMP_DIR/column{1,2,3,4}.txt >$TEMP_DIR/report.txt
+
+ # Sort by Sum (column 3), descending.
+ sort --general-numeric-sort --reverse --field-separator=$'\t' --key=3 $TEMP_DIR/report.txt >$TEMP_DIR/report-sorted.txt
+
+ # Compile final report, with column headers.
+ echo -e "Method\tCount\tSum\tMax" >"$OUTFILE"
+ cat $TEMP_DIR/report-sorted.txt >>"$OUTFILE"
+
+ # Output path to generated file
+ echo "$OUTFILE"
+}
+
+function cleanup() {
+ rm -f $TEMP_DIR/* && rmdir $TEMP_DIR 2>/dev/null
+}
+# Set up the cleanup function to be triggered upon script exit
+trap cleanup EXIT
+
+# Main script logic
+parse_params "$@"
+generate_report
+exit 0
diff --git a/test-tools/subtract-metrics-reports.py b/test-tools/subtract-metrics-reports.py
new file mode 100755
index 000000000..8f6fab384
--- /dev/null
+++ b/test-tools/subtract-metrics-reports.py
@@ -0,0 +1,80 @@
+#!/usr/bin/env python3
+#
+# Copyright 2023 Nordix Foundation.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+import argparse
+import csv
+
+
+def load_metrics_table(filename):
+ with open(filename) as tsvFile:
+ csvreader = csv.DictReader(tsvFile, dialect="excel-tab")
+ table = {}
+ for source_row in csvreader:
+ method, count, sum_time = source_row['Method'], source_row['Count'], source_row['Sum']
+ table[method] = { 'Count': int(float(count)), 'Sum': float(sum_time) }
+ return table
+
+
+def save_metrics_table(table, filename):
+ with open(filename, 'w', newline='') as outfile:
+ csvwriter = csv.writer(outfile, dialect="excel-tab")
+ csvwriter.writerow(["Method", "Count", "Sum"])
+ for method in table:
+ count, sum_time = table[method]['Count'], table[method]['Sum']
+ csvwriter.writerow([method, count, sum_time])
+
+
+def subtract_metrics_tables(table, table_to_subtract):
+ result = {}
+ for method in table:
+ result[method] = table[method]
+ for method in table_to_subtract:
+ result[method]['Count'] = result[method]['Count'] - table_to_subtract[method]['Count']
+ result[method]['Sum'] = result[method]['Sum'] - table_to_subtract[method]['Sum']
+ return filter_null_metrics_from_metrics_table(result)
+
+
+def filter_null_metrics_from_metrics_table(table):
+ result = {}
+ for method in table:
+ if table[method]['Count'] > 0:
+ result[method] = table[method]
+ return result
+
+
+if __name__ == "__main__":
+ parser = argparse.ArgumentParser()
+ parser.add_argument('-a', '--metrics-after',
+ required=True,
+ help='path to metrics table to subtract from',
+ dest='tsvpath_after',
+ type=str)
+ parser.add_argument('-b', '--metrics-before',
+ required=True,
+ help='path to metrics table to subtract',
+ dest='tsvpath_before',
+ type=str)
+ parser.add_argument('-o', '--output',
+ required=True,
+ help='path to output metrics table',
+ dest='outpath',
+ type=str)
+ args = parser.parse_args()
+ table1 = load_metrics_table(args.tsvpath_before)
+ table2 = load_metrics_table(args.tsvpath_after)
+ table_diff = subtract_metrics_tables(table2, table1)
+ save_metrics_table(table_diff, args.outpath)